import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Proteome {
    ArrayList<Protein> proteins;

    public Proteome(String fastaFile) {
        proteins = new ArrayList<>();
        // Erstellen des BufferedReaders im try-with-resources Block
        try (BufferedReader br = new BufferedReader(new FileReader(fastaFile))) {
            String line;
            // StringBuilder um die Sequenz komfortabel zwischenzuspeichern
            StringBuilder sb = new StringBuilder();
            String id = "";
            // while-Loop der in jedem Durchlauf eine Zeile in line einliest
            while ((line = br.readLine()) != null) {
                // Check: Ist es ein Header?
                if (line.startsWith(">")) {
                    // Wenn es ein Header ist:
                    // Check: Ist bereits eine Sequenz im StringBuilder?
                    if (sb.length() > 0) {
                        // Wenn bereits Sequenz in sb && aktuelle line ist header:
                        // Vorheriges Protein muss "fertig" sein: Protein hinzufügen
                        proteins.add(new Protein(id, sb.toString()));
                    }
                    // Wenn keine Sequenz in sb && aktuelle line ist header:
                    // Neue Sequenz-ID zwischenspeichern, neuen (leeren) sb erzeugen
                    id = line.substring(1);
                    sb = new StringBuilder();
                } else {
                    // Wenn es kein Header ist:
                    // Aktuelle Sequenz ist noch nicht zu Ende: Zu sb hinzufügen
                    sb.append(line);
                }
            }
	    // Nach dem Loop: Check ob noch eine ID gespeichert ist wenn ja, hinzufügen des letzten Proteins
	    // Denn der Loop in dem normalerweise hinzugefügt wird endet sobald er am Ende des Files angekommen
	    // ist, und dann ist ja immer noch die letzte Sequenz im Stringbuilder
            if (id.length() > 0) {
                proteins.add(new Protein(id, sb.toString()));
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public int getProteinCount() {
        return proteins.size();
    }

    public Protein getProtein(int i) {
        return proteins.get(i);
    }

    public void searchPattern(Pattern pattern) {
        // EURE IMPLEMENTATION HIER!
    }

    public static void main(String[] args) {
        Proteome p = new Proteome("C_elegans.pep.all.fa");
	// HIER EUER AUFRUF VON searchPattern
    }
}

